#if !defined(AFX_CONSOLE_H__B0C8B741_A776_11D3_A33F_8CED61F5D517__INCLUDED_)
#define AFX_CONSOLE_H__B0C8B741_A776_11D3_A33F_8CED61F5D517__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Console.h : header file
//

#define STATIC	1
#define UP		2
#define DOWN	4
#define FONT_HEIGHT				16
#define FONT_WIDTH				16
#define DISPLAY_FONT_HEIGHT		8
#define DISPLAY_FONT_WIDTH		8
#define UMAX					16
#define VMAX					32
#define COMP					0.000001
#define FLASH_SPEED				500
#define MAX_SIZE				64
#define XOFF					10
#define YOFF					5

struct console
{
	char *command; // Command
	char *help; // Optional help test
	void (*handler)(char *string); // Function hadler
};

/* Console prototypes */
void ConsoleCullbackfaces(char * command = NULL); 
void ConsoleGamma(char* command = NULL);

/////////////////////////////////////////////////////////////////////////////
// CConsole window

class CConsole : public CWnd
{
public:
	CConsole();
	virtual ~CConsole();
	void OnChar(char key);
	void OnKeyUp(int key);
	void FormatLine(char *text,...);
	void DisplayLine(char *text);
	void Restore();
	void Render();
	void Initialize();
	void ProccessCommand();
	void ProccessTab();
	void Close();

	bool				m_initialised;
	D3DTLVERTEX			m_v[4];
	LPDIRECT3DTEXTURE2	m_font,
						m_background;
	char				*m_BackgroundName,
						*m_FontName;
	int					m_nLines;
	CStringList			m_text,
						m_CommandHistory;
	CString				m_InputBuffer;
	CRect				m_size;
	float				m_yOffset;
	DWORD				m_mode;
	bool				m_bCursor;
	int					m_FlashCounter;
	POSITION			m_HistoryPos;
	int					m_CursorPos;
	int					m_TabCount;
	CString				m_PrevInput;
	CSize				m_FontSz;

	// Generated message map functions
protected:
};


#endif // !defined(AFX_CONSOLE_H__B0C8B741_A776_11D3_A33F_8CED61F5D517__INCLUDED_)
